#
#   HBS REDUCTION SUB ROUTINE
#
#   File conversion for CL : andorconv.cl
#
#   2005/08/25      M.Isogai  Ver.1.00  for AndorCCD
#   2005/11/02      M.Isogai  Ver.1.10  not execute if cryolist.org.dat exists
#   2009/05/28      M.Isogai  Ver.1.20  refine the script
#   2009/05/29      M.Isogai  Ver.1.21  change quotations

procedure andorconv()

begin

   string datf,tlist,datof
   string datfC,datofC
   file logfn 


   logfn = envget( "_logfile" )
#   logfn="tmpaho"


#-- check task declaration
   if( !deftask ("grep") )
     {
       printf("Task grep is now defined\n")
       printf("Task grep is now defined\n", >> logfn )
       task($grep = "$foreign")
     }
   if( !deftask ("sed") )
     {
       printf("Task sed is now defined\n")
       printf("Task sed is now defined\n", >> logfn )
       task($sed = "$foreign")
     }

#-- set filename and listname
   datf="cryolist.dat"
   tlist=mktemp("tmp.inlist.")
   datof="cryolist.org.dat"	

   datfC="CRYOLIST.DAT"
   datofC="CRYOLIST.ORG.DAT"


   if( access(datf) )
     {
       if( !access(datof) )
         {
	   printf("...Rename %s to %s\n", datf, datof)
	   printf("...Rename %s to %s\n", datf, datof, >> logfn)
           rename(datf, datof, field="all")


           printf("...Change extension of fits-frame from fit to fts\n")
           printf("...Change extension of fits-frame from fit to fts\n" \
	                                , >> logfn)
           grep('-v \#', datof) | cut('-c1-12', > tlist)
           rename('@'//tlist, "fts", field="extn")

	   printf("...Make new %s\n", datf)
	   printf("...Make new %s\n", datf, >> logfn)
           sed('\'s/.fit/.fts/\'', datof, > datf)

           delete(tlist, ver-)

         }
       else
	 {
           printf("andorconv has aleady been executed.\n")
           printf("andorconv has aleady been executed.\n", >> logfn)
           bye
         }
     }
   else if( access(datfC) )
     {
       if( !access(datofC) )
         {
	   printf("...Rename %s to %s\n", datfC, datofC)
	   printf("...Rename %s to %s\n", datfC, datofC, >> logfn)
           rename(datfC, datofC, field="all")

           printf("...Change extension of fits-frame from fit to fts\n")
           printf("...Change extension of fits-frame from fit to fts\n" \
	                                , >> logfn)
           grep('-v \#', datofC) | cut('-c1-12', > tlist)
           rename('@'//tlist, "FTS", field="extn")

	   printf("...Make new %s\n", datfC)
	   printf("...Make new %s\n", datfC, >> logfn)
           sed('\'s/.fit/.fts/\'', datofC, > datfC)

           delete(tlist, ver-)

         }
       else
	 {
           printf("andorconv has aleady been executed.\n")
           printf("andorconv has aleady been executed.\n", >> logfn)
           bye
         }
     }
   else
    {
       printf("Error!: Neither %s nor %s was found.\n",datf,datfC)
       printf("Error!: Neither %s nor %s was found.\n",datf,datfC, >> logfn)
       bye
    }

#-- delete temporal list
   if( access(tlist) ) 
     {
      delete(tlist, ver-)
     }
end
