#
#       HBS REDUCTION SUB ROUTINE
#
#       Display and shift images: hbsdisplay2.cl
#       ( original script ; hbsdisplay.cl by K.Kawabata )
#
#     * hbsdisplay.cl
#       1995/10/05      K.Kawabata
#       1996/06/29      K.Kawabata Ver. 1.10  (enhance-scaling)
#       1996/11/06      K.Kawabata (delete mode)
#
#     * hbsdisplay2.cl
#       2004/10/13 v2.0  H.Akitaya (interactive cosmic ray rejection etc.)
#
#

procedure hbsdisplay( inlist )

file inlist	{ prompt = "Input image list" }

begin

  string fn, tmp_fn, bkup_fn,buf, buf1, buf2, buf3
  string fn_lst[400]
  int file_num, current_file_num, tmp_num
  int xsft, ysft
  int x
  int hbpf_x1,  hbpf_x2, hbpf_y1, hbpf_y2, hbpf_num
  bool flag_xyscale = no
  bool flag_zscale = yes
  real xscale=1.00
  real yscale=1.00
  real xscaletmp, yscaletmp
  real zmin=1000.
  real zmax=5000.
  real zmintmp, zmaxtmp

  print( "" )
  print( "---------------------------------" )
  print( " Display and shift(if necessary)" )
  print( "---------------------------------" )
  print( "" )

  buf = " "
  list = inlist
  tmp_fn = mktemp( "hbs.tmp.image." )
  bkup_fn = mktemp( "hbs.tmp.image." )
  xscaletmp = xscale
  yscaletmp = yscale

  print( "Set Magnify Scaling ? ( [y]:yes [RET]:no )" )
  x = scan( buf )
  while( x != 0 && buf != "y" && buf != "n" )
    x = scan( buf )
  if( buf == "y" )
  {
    flag_xyscale = yes
    print( "Input xmag and ymag (default "//xscale//" "//yscale//")" )
    x = scan( buf, buf1 )
    while( x != 0 && x != 2 )
      x = scan( buf, buf1 )
    if( x == 2 ){
      xscale = real( buf )
      yscale = real( buf1 )
    }
  }
  print( "Set Intensity Scaling ? ( [y]:yes [RET]:no )" )
  x = scan( buf )
  while( x != 0 && buf != "y" && buf != "n" )
    x = scan( buf )
  if( buf == "y" )
  {
    flag_zscale = no
    print( "Input z1 and z2 (default "//zmin//" "//zmax//")" )
    x = scan( buf, buf1 )
    while( x != 0 && x != 2 )
      x = scan( buf, buf1 )
    if( x == 2 ){
      zmin = real( buf )
      zmax = real( buf1 )
    }
  }

  file_num = 0
  while( fscan(list, fn) != EOF ){
  fn_lst[file_num+1]=fn
   file_num += 1
   }
  
  print( "# ", file_num, " files." )

  current_file_num=1
  while(  current_file_num <= file_num )
  {
    fn = fn_lst[current_file_num]
    print( "IMAGE- "//fn )
      display( fn, 1, zscale=flag_zscale, zrange=flag_zscale, \
               z1=zmin, z2=zmax,\
               fill-, xmag=xscale, ymag=yscale )
    
#    if( flag_xyscale == 0 && flag_zscale == 0 )
#      display( fn, 1, zscale+, zrange+,\
#               fill-, xmag=xscale, ymag=yscale )
#    if( flag_xyscale == 1 && flag_zscale == 0 )
#      display( fn, 1, zscale+, zrange+,\
#               fill-, xmag=xscale, ymag=yscale )
#    if( flag_xyscale == 0 && flag_zscale == 1 )
#      display( fn, 1, zscale-, zrange-, z1=zmin, z2=zmax,\
#               fill- )
#    if( flag_xyscale == 1 && flag_zscale == 1 )
#      display( fn, 1, zscale+, zrange+, z1=zmin, z2=zmax,\
#               fill-, xmag=xscale, ymag=yscale )

query :
    print("[RET]:next [-]:previous [j]:jump [l]:list\n[i]:intensity [I]:default intensity [m]:magnify \n[s]:shift [d]:delete [r]:redisplay [e]:imexam [b] hbs_boxpixfix >>")
    x = scan(buf)
    while( x != 0 && buf != "s" && buf != "d" && buf != "i" && \
    buf != "m" && buf != "r" && buf != "I" && buf != "e" && \
     buf != "l" && buf != "j" && buf != "-" && buf != "b" && buf != "q" )
      x = scan(buf)
      
    # quit
    if( buf == "q" )
    {
      return
    }

    # list file name
    if( buf == "l" )
    {
      for( tmp_num = 1; tmp_num <= file_num; tmp_num+=1)
         printf( "%5d %30s\n", tmp_num,  fn_lst[tmp_num] )
      goto query
    }

    # interractive cosmic ray rejection
    if( buf == "b" )
    {
      imcopy( fn, bkup_fn, verbose- )
      print( "Input x1 x2 y1 y2" )
      hbpf_num=0
      x = scan( buf, buf1, buf2, buf3 )
      while( x >= 1 && x <= 4 ){
	 if( x == 4 ){
         hbpf_x1 = real( buf )
         hbpf_x2 = real( buf1 )
         hbpf_y1 = real( buf2 )
         hbpf_y2 = real( buf3 )
         hbs_boxpixfix( bkup_fn,  hbpf_x1,  hbpf_x2, hbpf_y1, hbpf_y2 )
	 }
	 x = scan( buf, buf1, buf2, buf3 )
      }

      display( fn, 2, zscale=flag_zscale, zrange=flag_zscale, \
             z1=zmin, z2=zmax,\
             fill-, xmag=xscale, ymag=yscale )

      display( bkup_fn, 1, zscale=flag_zscale, zrange=flag_zscale, \
             z1=zmin, z2=zmax,\
             fill-, xmag=xscale, ymag=yscale )

      print( "Check the result by FRAME->BLINK ion ds9.\nConfirm ? [y or others]" )
        x = scan(buf)
	if ( buf == "y" )
	{
	   print("applying pixfix...")
	   imdelete( fn )
	   imcopy( bkup_fn, fn, verbose- )
	   imdelete( bkup_fn )
	     }
      display( fn, 1, zscale=flag_zscale, zrange=flag_zscale, \
             z1=zmin, z2=zmax,\
             fill-, xmag=xscale, ymag=yscale )
 
      goto query
    }
    
    # execute imexamine
    if( buf == "e" )
    {
      imexamine( fn, 1 )
      goto query
    }
    # re-display
    if( buf == "r" )
    {
      display( fn, 1, zscale=flag_zscale, zrange=flag_zscale, \
               z1=zmin, z2=zmax,\
               fill-, xmag=xscale, ymag=yscale )
      goto query
    }
    if( buf == "i" )
    {
      print( "Input z1 and z2 (default "//zmin//" "//zmax//")" )
      x = scan( buf, buf1 )
      while( x != 0 && x != 2 )
        x = scan( buf, buf1 )
      if( x == 2 ){
        zmintmp = real( buf )
        zmaxtmp = real( buf1 )
      }
      display( fn, 1, zscale-, zrange-, z1=zmintmp, z2=zmaxtmp,\
              fill-, xmag=xscale, ymag=yscale )
      goto query
    }
    # change default intensity
    if( buf == "I" )
    {
      flag_zscale = no
      print( "Input z1 and z2 (default "//zmin//" "//zmax//")" )
      x = scan( buf, buf1 )
      while( x != 0 && x != 2 )
        x = scan( buf, buf1 )
      if( x == 2 ){
        zmin = real( buf )
        zmax = real( buf1 )
      }
      display( fn, 1, zscale-, zrange-, z1=zmin, z2=zmax,\
              fill-, xmag=xscale, ymag=yscale )
      goto query
    }
    if( buf == "m" )
    {
      print( "Input xmag and ymag (default "//xscaletmp//" "//yscaletmp//")" )
      x = scan( buf, buf1 )
      while( x != 0 && x != 2 )
        x = scan( buf, buf1 )
      if( x == 2 ){
        xscaletmp = real( buf )
        yscaletmp = real( buf1 )
      }
      display( fn, 1, zscale+, zrange+,\
               fill-, xmag=xscaletmp, ymag=yscaletmp )
      goto query
    }
    if( buf == "s" )
    {
    
shift :
      print("How shift ? ( x, y )  >>")
      while( scan( xsft, ysft ) != 2 ) {}
      imshift( input=fn, output=tmp_fn, xshift=xsft, yshift=ysft,\
               interp_type = "linear" )
      display( tmp_fn, 1 )
      print("[y]:update and next  [r]:retry  [n]:no shift  >>")
      x = scan(buf)
      while( buf != "y"  && buf != "r" && buf != "n")
        x = scan(buf)
      if( buf == "y" )
      {
        imdelete( fn )
        imrename( oldname=tmp_fn, newname=fn, ver- )
      }
      if( buf == "r" )
      {
        imdelete( tmp_fn )
        goto shift
      }
      if( buf == "n" )
      {
        imdelete( tmp_fn )
      }
    }
    if( buf == "d" )
      imdelete( fn, ver- )

    if( buf == "-" ){
      if ( current_file_num != 1 )
        current_file_num -= 1
	}
    else if( buf == "j" )
      {
        printf ( "Input file number [1-%d]", file_num )
        x = scan( buf )
        if( x == 1 )
        {
           tmp_num = int( buf )
	   if ( tmp_num >= 1 && tmp_num <= file_num)
	      current_file_num = tmp_num
	}
      }
    else
        current_file_num += 1    

  }

end
