#
#       HBS REDUCTION SUB ROUTINE
#
#       average I, q and u spectrum (use HBS.list)
#
#       1997/03/31      K.Kawabata ver.0.10
#       1997/09/09      K.Kawabata ver.1.00  using HBS.list
#       1998/05/31      K.Kawabata ver.2.10  unification and e/o rejection
#
#
procedure hbsiquave

begin

  file listoflist, iqulist, grouplist
  string hbslist[250]
  string khead[250]
  string klist0, klist1, klist2, klist3
  string qlist[250], ulist[250], ilist[250], diaph[250], filter[250]
  int max_theta_n[250]
  int c, i, j, k, n, n_list
  int  n_allc, n_nextc
  string fn_group
  int x1, x2
  real l1, l2, la, lb

  string fn
  file tmp_fn, tmp_list
  file tmp_fn1, tmp_fn2, tmp_fn3
  file tmp_i1, tmp_i2, tmp_q, tmp_u
  file tmp_k0, tmp_k1, tmp_k2, tmp_k3
  int n_i, n_q, n_u
  int n_k0, n_k1, n_k2, n_k3
  file fn_i1ave, fn_i1sig, fn_i1rej
  file fn_i2ave, fn_i2sig, fn_i2rej
  file fn_qave, fn_qsig, fn_qrej
  file fn_uave, fn_usig, fn_urej
  file fn_k0ave, fn_k0sig, fn_k0rej
  file fn_k1ave, fn_k1sig, fn_k1rej
  file fn_k2ave, fn_k2sig, fn_k2rej
  file fn_k3ave, fn_k3sig, fn_k3rej
  string fn_head, fn_uplow
  file binfile
  string buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7, buf8
  real rsigma = 3.0
  int flag # 0:lower 1:upper -1:other

#--- initial settings

  listoflist = envget( "_rootlist" )
  iqulist = envget( "_iqulist" )
  grouplist = envget( "_grouplist" )
  l1 = int( envget( "_rej_x1" ) )
  l2 = int( envget( "_rej_x2" ) )

  tmp_list = mktemp( "hbs.tmp.list." )
  tmp_fn = mktemp( "hbs.tmp.list." )
  tmp_fn1 = mktemp( "hbs.tmp.list." )
  tmp_fn2 = mktemp( "hbs.tmp.list." )
  tmp_fn3 = mktemp( "hbs.tmp.list." )
  tmp_i1 = mktemp( "hbs.tmp.list." )
  tmp_i2 = mktemp( "hbs.tmp.list." )
  tmp_q = mktemp( "hbs.tmp.list." )
  tmp_u = mktemp( "hbs.tmp.list." )
  tmp_k0 = mktemp( "hbs.tmp.list." )
  tmp_k1 = mktemp( "hbs.tmp.list." )
  tmp_k2 = mktemp( "hbs.tmp.list." )
  tmp_k3 = mktemp( "hbs.tmp.list." )

  buf = ""

  print( "" )
  print( "-------------------------------------------------" )
  print( " Averaging i, q, u spectra for photometric group"
  print( "-------------------------------------------------" )
  print( "" )

#----- delete old images

  imdelete( "*.ave.imh", ver- )
  imdelete( "*.sig.imh", ver- )

#----- checking list

  if( access( grouplist ) == 1 )
    delete( grouplist, ver- )

#----- Scanning the list file

  if( access( iqulist ) == 0 )
  {
    printf( "Cannot find '%s'   Please do hbsiqugroup\n", iqulist )
    bye
  }

  n_list = 0
  list = iqulist
  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7, buf8 ) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "HBS" )
    {
      print( "The list-file ", iqulist, " is not produced by HBSiquGROUP.CL" )
      bye
    }
    n_list += 1
    hbslist[n_list] = buf1
    ilist[n_list] = buf2
    qlist[n_list] = buf3
    ulist[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    max_theta_n[n_list] = int( buf7 )
    khead[n_list] = buf8
  }

mainstart:

  for( k=1; k<=n_list; k+=1 )
  {

  flag = 999
  n_i = 0
  n_q = 0
  n_u = 0
  n_k0 = 0
  n_k1 = 0
  n_k2 = 0
  n_k3 = 0
  if( access( tmp_i1 ) )
    delete( tmp_i1 )
  if( access( tmp_i2 ) )
    delete( tmp_i2 )
  if( access( tmp_q ) )
    delete( tmp_q )
  if( access( tmp_u ) )
    delete( tmp_u )
  if( access( tmp_k0 ) )
    delete( tmp_k0 )
  if( access( tmp_k1 ) )
    delete( tmp_k1 )
  if( access( tmp_k2 ) )
    delete( tmp_k2 )
  if( access( tmp_k3 ) )
    delete( tmp_k3 )

  fn_group = str( k )

next2:
  n_allc = strlen( fn_group )
  n_nextc = stridx( ",", fn_group )
  if( n_nextc == 0 )
    n_nextc = n_allc + 1

  i = int( substr( fn_group, 1, (n_nextc-1) ) )
  if( i < 1 || i > n_list )
    goto nextstep1

  if( substr( diaph[i], 4, 4 ) == "U" )
  {
    if( flag < 100 && flag != 1 )
    {
      printf( "%d is not UPPER hole group!! Ignored.\n", i )
      goto nextstep1
    }
    printf( "an UPPER hole group '%d' is selected\n", i )
    fn_uplow = "u"
    flag = 1
  }
  else
  {
    if( substr( diaph[i], 4, 4 ) == "L" )
    {
      if( flag < 100 && flag != 0 )
      {
        printf( "%d is not LOWER hole group!! Ignored.\n", i )
        goto nextstep1
      }
      printf( "a LOWER hole group '%d' is selected\n", i )
      fn_uplow = "l"
      flag = 0
    }
    else
    {
      printf( "an OTHER hole group is selected\n" )
      fn_uplow = "o"
      flag = -1
    }
  }

  if( access( ilist[i] ) == 1 )
  {
    list = ilist[i]
    while( fscan( list, buf1, buf2, buf3, buf4 ) != EOF )
    {
      if( access( buf3//".imh" ) )
        printf( "%s\n", buf3, >> tmp_i1 )
      if( access( buf4//".imh" ) )
        printf( "%s\n", buf4, >> tmp_i2 )
      n_i += 1
    }
  }
  if( access( qlist[i] ) == 1 )
  {
    list = qlist[i]
    while( fscan( list, buf, buf1, buf2, buf3 ) != EOF )
    {
      if( access( buf3//".imh" ) )
        printf( "%s\n", buf3, >> tmp_q )
      n_q += 1
    }
  }
  if( access( ulist[i] ) == 1 )
  {
    list = ulist[i]
    while( fscan( list, buf, buf1, buf2, buf3 ) != EOF )
    {
      if( access( buf3//".imh" ) )
        printf( "%s\n", buf3, >> tmp_u )
      n_u += 1
    }
  }

  klist0 = khead[i]//"0"
  klist1 = khead[i]//"1"
  klist2 = khead[i]//"2"
  klist3 = khead[i]//"3"

  if( access( klist0 ) == 1 )
  {
    list = klist0
    while( fscan( list, buf, buf1 ) != EOF )
    {
      if( access( buf1//".imh" ) )
        printf( "%s\n", buf1, >> tmp_k0 )
      n_k0 += 1
    }
  }
  if( access( klist1 ) == 1 )
  {
    list = klist1
    while( fscan( list, buf, buf1 ) != EOF )
    {
      if( access( buf1//".imh" ) )
        printf( "%s\n", buf1, >> tmp_k1 )
      n_k1 += 1
    }
  }
  if( access( klist2 ) == 1 )
  {
    list = klist2
    while( fscan( list, buf, buf1 ) != EOF )
    {
      if( access( buf1//".imh" ) )
        printf( "%s\n", buf1, >> tmp_k2 )
      n_k2 += 1
    }
  }
  if( access( klist3 ) == 1 )
  {
    list = klist3
    while( fscan( list, buf, buf1 ) != EOF )
    {
      if( access( buf1//".imh" ) )
        printf( "%s\n", buf1, >> tmp_k3 )
      n_k3 += 1
    }
  }

  if( n_nextc < n_allc )
  {
    fn_group = substr( fn_group, (n_nextc + 1), n_allc )
    goto next2
  }

#  printf( "OK. %s is registed.  More ? [y/n]  >> ", hbslist[i] )
#  c = scan( buf )
#  while( buf != "y" && buf != "n" )
#    c = scan( buf )
#  if( buf == "y" )
#    goto nextstep1

#----- assign filename

  buf = ""
#  printf( "\nRoot-name of output table ([0]: grouping again) >> " )
#  c = scan( buf )
#  while( c == 0 || strlen( buf ) < 1 )
#    c = scan( buf )
#  if( buf == "0" )
#    goto nextstep1  
#  fn_head = buf
  buf1 = hbslist[k]
  c = stridx( ".", buf1 )
  buf = substr( buf1, (c+1), strlen( buf1 ) )
  buf1 = buf
  c = stridx( ".", buf1 )
  buf = substr( buf1, (c+1), strlen( buf1 ) )
  c = stridx( ".", buf )
  
  fn_head = substr( buf, 1, (c-1) )
  printf( "-- %s  %s --\n", hbslist[k], fn_head )

  fn_i1ave = fn_head//"i1.ave"
  fn_i1sig = fn_head//"i1.sig"
  fn_i1rej = fn_head//"i1.rej"
  fn_i2ave = fn_head//"i2.ave"
  fn_i2sig = fn_head//"i2.sig"
  fn_i2rej = fn_head//"i2.rej"
  fn_qave = fn_head//"q.ave"
  fn_qsig = fn_head//"q.sig"
  fn_qrej = fn_head//"q.rej"
  fn_uave = fn_head//"u.ave"
  fn_usig = fn_head//"u.sig"
  fn_urej = fn_head//"u.rej"
  fn_k0ave = fn_head//"k0.ave"
  fn_k0sig = fn_head//"k0.sig"
  fn_k0rej = fn_head//"k0.rej"
  fn_k1ave = fn_head//"k1.ave"
  fn_k1sig = fn_head//"k1.sig"
  fn_k1rej = fn_head//"k1.rej"
  fn_k2ave = fn_head//"k2.ave"
  fn_k2sig = fn_head//"k2.sig"
  fn_k2rej = fn_head//"k2.rej"
  fn_k3ave = fn_head//"k3.ave"
  fn_k3sig = fn_head//"k3.sig"
  fn_k3rej = fn_head//"k3.rej"

#----- Clipping sigma

#  printf( "Clipping Sigma for %s  >> ", fn_head )
#  c = scan( rsigma )
#  while( rsigma <= 0.0 )
#    c = scan( rsigma )
  rsigma = 3.0

#----- display grouped list and enter title

#  printf( "\n------ binned I images (%d) -----\n", n_i )
#  type( tmp_i1 )
#  printf( "\n------ original I images (%d) -----\n", n_i )
#  type( tmp_i2 )
#  printf( "\n------ q(=Q/I) images (%d) -----\n", n_q )
#  type( tmp_q )
#  printf( "\n------ u(=U/I) images (%d) -----\n", n_u )
#  type( tmp_u )
#  printf( "\n------ kappa(0) images (%d) -----\n", n_k0 )
#  type( tmp_k0 )
#  printf( "\n------ kappa(1) images (%d) -----\n", n_k1 )
#  type( tmp_k1 )
#  printf( "\n------ kappa(2) images (%d) -----\n", n_k2 )
#  type( tmp_k2 )
#  printf( "\n------ kappa(3) images (%d) -----\n", n_k3 )
#  type( tmp_k3 )

#----- binning region

  x1 = 0
  x2 = 0
  la = 0.0
  lb = 0.0
  c = 0
  binfile = hbslist[i]//".binew"
  list = binfile
  while( fscan( list, buf1, buf2 ) != EOF )
  {
    c += 1
    la = real( buf1 )
    if( la >= l1 && lb < l1 )
      x1 = c
    if( la > l2 && lb <= l2 )
      x2 = c
    lb = la
  }
  if( x1 == 0 || x2 == 0 )
  {
    printf( "Error in reading '%s'\n", hbslist[i]//".binew" )
    bye
  }

#----- i(binned)

  if( n_i > 0 )
  {
    printf( "Now averaging I1-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_i1, x1, x2, fn_i1ave, fn_i1sig, fn_i1rej, rsigma )

    if( access( fn_i1rej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_i1rej )
      type( fn_i1rej )
    }
    delete( tmp_i1, ver- )
  }

#----- i(original)

  if( n_i > 0 )
  {
    printf( "Now averaging I2-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_i2, 0, 0, fn_i2ave, fn_i2sig, fn_i2rej, rsigma )

    delete( tmp_i2, ver- )
  }

#----- kappa-0

  if( n_k0 > 0 )
  {
    printf( "Now averaging kappa(0)-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_k0, x1, x2, fn_k0ave, fn_k0sig, fn_k0rej, rsigma )

    if( access( fn_k0rej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_k0rej )
      type( fn_k0rej )
    }

    delete( tmp_k0, ver- )
  }

#----- kappa-1

  if( n_k1 > 0 )
  {
    printf( "Now averaging kappa(1)-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_k1, x1, x2, fn_k1ave, fn_k1sig, fn_k1rej, rsigma )

    if( access( fn_k1rej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_k1rej )
      type( fn_k1rej )
    }

    delete( tmp_k1, ver- )
  }

#----- kappa-2

  if( n_k2 > 0 )
  {
    printf( "Now averaging kappa(2)-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_k2, x1, x2, fn_k2ave, fn_k2sig, fn_k2rej, rsigma )

    if( access( fn_k2rej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_k2rej )
      type( fn_k2rej )
    }

    delete( tmp_k2, ver- )
  }

#----- kappa-3

  if( n_k3 > 0 )
  {
    printf( "Now averaging kappa(3)-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_k3, x1, x2, fn_k3ave, fn_k3sig, fn_k3rej, rsigma )

    if( access( fn_k3rej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_k3rej )
      type( fn_k3rej )
    }

    delete( tmp_k3, ver- )
  }

#----- q

  if( n_q > 0 )
  {
    printf( "Now averaging q-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_q, x1, x2, fn_qave, fn_qsig, fn_qrej, rsigma )

    if( access( fn_qrej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_qrej )
      type( fn_qrej )
    }
    imdelete( fn_qsig, ver- )

    if( n_k0 > 0 )
    {
      imfunc( fn_k0sig, tmp_fn1, "square", ver- )
      imarith( tmp_fn1, "/", fn_k0ave, tmp_fn1, pixtype="real",\
                calctype="real", ver- )
      imarith( tmp_fn1, "/", fn_k0ave, tmp_fn1, pixtype="real",\
                calctype="real", ver- )
    }
    else
    {
      imcopy( fn_i2ave, tmp_fn1, ver- )
      imreplace( tmp_fn1, 0 )
    }
    if( n_k2 > 0 )
    {
      imfunc( fn_k2sig, tmp_fn2, "square", ver- )
      imarith( tmp_fn2, "/", fn_k2ave, tmp_fn2, pixtype="real",\
                calctype="real", ver- )
      imarith( tmp_fn2, "/", fn_k2ave, tmp_fn2, pixtype="real",\
              calctype="real", ver- )
    }
    else
    {
      imcopy( fn_i2ave, tmp_fn2, ver- )
      imreplace( tmp_fn2, 0 )
    }
    imarith( tmp_fn1, "+", tmp_fn2, tmp_fn1, pixtype="real",\
              calctype="real", ver- )
    imdelete( tmp_fn2, ver- )

    if( n_k0 > 0 && n_k2 > 0 )
    {
      imarith( fn_k0ave, "/", fn_k2ave, tmp_fn2, pixtype="real",\
                calctype="real", ver- )
    }
    else
    {
      if( n_k0 > 0 )
      {
        imcopy( fn_k0ave, tmp_fn2, ver- )
      }
      else
      {
        imarith( 1.0, "/", fn_k2ave, tmp_fn2, pixtype="real",\
                  calctype="real", ver- )
      }
    }
    imfunc( tmp_fn2, tmp_fn3, "sqrt", ver- )
    imarith( tmp_fn3, "+", 1, tmp_fn3, pixtype="real",\
              calctype="real", ver- )
    imfunc( tmp_fn3, tmp_fn3, "square", ver- )
    imfunc( tmp_fn3, tmp_fn3, "square", ver- )
    imfunc( tmp_fn2, tmp_fn2, "abs", ver- )
    imarith( tmp_fn1, "*", tmp_fn2, tmp_fn1, pixtype="real",\
              calctype="real", ver- )
    imarith( tmp_fn1, "/", tmp_fn3, tmp_fn1, pixtype="real",\
              calctype="real", ver- )

    imfunc( tmp_fn1, fn_qsig, "sqrt", ver- )
    imdelete( tmp_fn1, ver- )
    imdelete( tmp_fn2, ver- )
    imdelete( tmp_fn3, ver- )

    delete( tmp_q, ver- )
  }

#----- u

  if( n_u > 0 )
  {
    printf( "Now averaging u-images (%3.1fsigma rejection )\n", rsigma )
    hbsaverage( tmp_u, x1, x2, fn_uave, fn_usig, fn_urej, rsigma )

    if( access( fn_urej ) == 1 )
    {
      printf( "These rejectioned images are recorded in %s\n", fn_urej )
      type( fn_urej )
    }
    imdelete( fn_usig, ver- )

    if( n_k1 > 0 )
    {
      imfunc( fn_k1sig, tmp_fn1, "square", ver- )
      imarith( tmp_fn1, "/", fn_k1ave, tmp_fn1, pixtype="real",\
                calctype="real", ver- )
      imarith( tmp_fn1, "/", fn_k1ave, tmp_fn1, pixtype="real",\
                calctype="real", ver- )
    }
    else
    {
      imcopy( fn_i2ave, tmp_fn1, ver- )
      imreplace( tmp_fn1, 0 )
    }
    if( n_k3 > 0 )
    {
      imfunc( fn_k3sig, tmp_fn2, "square", ver- )
      imarith( tmp_fn2, "/", fn_k3ave, tmp_fn2, pixtype="real",\
                calctype="real", ver- )
      imarith( tmp_fn2, "/", fn_k3ave, tmp_fn2, pixtype="real",\
                calctype="real", ver- )
    }
    else
    {
      imcopy( fn_i2ave, tmp_fn2, ver- )
      imreplace( tmp_fn2, 0 )
    }
    imarith( tmp_fn1, "+", tmp_fn2, tmp_fn1, pixtype="real",\
              calctype="real", ver- )
    imdelete( tmp_fn2, ver- )

    if( n_k1 > 0 && n_k3 > 0 )
    {
      imarith( fn_k1ave, "/", fn_k3ave, tmp_fn2, pixtype="real",\
                calctype="real", ver- )
    }
    else
    {
      if( n_k1 > 0 )
      {
        imcopy( fn_k1ave, tmp_fn2, ver- )
      }
      else
      {
        imarith( 1.0, "/", fn_k3ave, tmp_fn2, pixtype="real",\
                  calctype="real", ver- )
      }
    }
    imfunc( tmp_fn2, tmp_fn3, "sqrt", ver- )
    imarith( tmp_fn3, "+", 1, tmp_fn3, pixtype="real",\
              calctype="real", ver- )
    imfunc( tmp_fn3, tmp_fn3, "square", ver- )
    imfunc( tmp_fn3, tmp_fn3, "square", ver- )
    imfunc( tmp_fn2, tmp_fn2, "abs", ver- )
    imarith( tmp_fn1, "*", tmp_fn2, tmp_fn1, pixtype="real",\
              calctype="real", ver- )
    imarith( tmp_fn1, "/", tmp_fn3, tmp_fn1, pixtype="real",\
              calctype="real", ver- )

    imfunc( tmp_fn1, fn_usig, "sqrt", ver- )
    imdelete( tmp_fn1, ver- )
    imdelete( tmp_fn2, ver- )
    imdelete( tmp_fn3, ver- )

    delete( tmp_u, ver- )
  }

#----- record log file

  printf( "\n" )
  printf( "%s %s %s  %d %d %d\n", fn_head, diaph[i], binfile,\
          n_i, n_q, n_u, >> grouplist )

  }

end
